module Selenium
  module EmulatedFeatures
    module ResponseCode
      def response_code
        execute_script <<-js
          if(document.__SEF__ && document.__SEF__.request) {
            return document.__SEF__.request.status;
          }

          var baseURI = document.baseURI;

          /* Firefox */
          if (/about:neterror/.test(baseURI)) return null;

          /* Safari */
          if (/Safari.app/.test(baseURI)) return null;

          /* Chrome */
          if (/chromewebdata/.test(baseURI)) return null;

          document.__SEF__ = {}
          document.__SEF__.request = new XMLHttpRequest();

          document.__SEF__.request.open("GET", document.location, false);
          document.__SEF__.request.send(null);
          return document.__SEF__.request.status;
        js
      end

    rescue
      nil
    end
  end
end
